package com.gxlu.ps.netcruise.md.buffer;

import com.gxlu.ps.netcruise.md.Configer;
import com.gxlu.ps.netcruise.md.GlobalInstance;
import com.gxlu.ps.netcruise.md.util.Command;
import java.util.LinkedList;
import java.util.NoSuchElementException;
import org.apache.log4j.Logger;

/* loaded from: com_gxlu_ps_netcruise_md_buffer.jar:com/gxlu/ps/netcruise/md/buffer/CmdPool.class */
public class CmdPool {
    private static CmdPool instance = null;
    protected CmdFile cmdFile;
    protected LinkedList cmds;
    private Logger logger = null;

    public static synchronized CmdPool getInstance() {
        if (instance == null) {
            try {
                Configer cfger = GlobalInstance.getInstance().getConfiger();
                instance = new CmdPool(cfger.getCmdFilePath());
            } catch (Exception e) {
                return (CmdPool) null;
            }
        }
        return instance;
    }

    private CmdPool(String cmdFilePath) {
        this.cmdFile = new CmdFile(cmdFilePath);
        this.cmds = this.cmdFile.loadAllCmds();
        if (this.cmds == null) {
            this.cmds = new LinkedList();
        }
    }

    public synchronized void saveCmd(Command cmd) {
        this.cmds.add(cmd);
        notify();
    }

    public synchronized Command getCmd() {
        if (this.cmds.size() == 0) {
            try {
                wait();
            } catch (InterruptedException e) {
            }
        }
        try {
            Command cmd = (Command) this.cmds.removeFirst();
            return cmd;
        } catch (NoSuchElementException e2) {
            return (Command) null;
        }
    }

    public synchronized void pushbackCmd(Command cmd) {
        this.cmds.addFirst(cmd);
        notify();
    }

    public synchronized void savePool() {
        this.cmdFile.saveCmds(this.cmds);
    }

    public synchronized void saveAndClearPool() {
        this.cmdFile.saveCmds(this.cmds);
        this.cmds.clear();
    }
}
